<?php

class WebSettings implements JsonSerializable
{
    public $defaultLanguage = 'English',
        $defaultTheme = 'Default',
        $dateFormat = 'd-m-Y H:i:s',
        $timeFormat = 'H:i:s',
        $logo = '../inc/img/logo.png',
        $fullLogo = '../inc/img/full_logo.png',
        $loginBackground = '../inc/img/bg.jpg',
        $loginVideo = '',
        $restAPIUrl = 'http://localhost:4777',
        $restAPISecret = '';

    public function __construct($json = false) {
        if ($json) $this->set(json_decode($json, true));
    }

    public function set($data) {
        foreach ($data AS $key => $value) {
            if (is_array($value)) {
                $sub = new WebSettings();
                $sub->set($value);
                $value = $sub;
            }
            $this->{$key} = $value;
        }
    }

    public function jsonSerialize(): array
    {
        return [
            'defaultLanguage' => $this->defaultLanguage,
            'defaultTheme' => $this->defaultTheme,
            'dateFormat' => $this->dateFormat,
            'timeFormat' => $this->timeFormat,
            'logo' => $this->logo,
            'fullLogo' => $this->fullLogo,
            'loginBackground' => $this->loginBackground,
            'loginVideo' => $this->loginVideo,
            'restAPIUrl' => $this->restAPIUrl,
            'restAPISecret' => $this->restAPISecret,
        ];
    }

    public static function jsonDeserialize($json): WebSettings {
        return json_decode($json);
    }
}