<?php
include '../permissions.php';
handlePermission('view_analytics');
header('Content-type: application/json');
ini_set('memory_limit', '256M');

$type = $_GET['dataload'];

switch ($type) {
    case 'mnp':
        //echo $pdo->query('SELECT COUNT(id) FROM nm_players WHERE firstlogin >= UNIX_TIMESTAMP((LAST_DAY(NOW())+INTERVAL 1 DAY)-INTERVAL 1 MONTH)*1000')->fetchColumn();
        echo $pdo->query('SELECT COUNT(*) FROM nm_players WHERE firstlogin >= UNIX_TIMESTAMP(CURDATE()- INTERVAL 1 MONTH)*1000;')->fetchColumn();
        break;
    case 'wnp':
        echo $pdo->query('SELECT COUNT(*) FROM nm_players WHERE firstlogin >= UNIX_TIMESTAMP(CURDATE()- INTERVAL 1 WEEK)*1000;')->fetchColumn();
        break;
    case 'dnp':
        echo $pdo->query('SELECT COUNT(*) FROM nm_players WHERE firstlogin >= UNIX_TIMESTAMP(CURDATE())*1000;')->fetchColumn();
        break;
    case 'mrp':
        //$stmnt = $pdo->query('SELECT COUNT(DISTINCT(uuid)) FROM nm_sessions WHERE start >= UNIX_TIMESTAMP((LAST_DAY(NOW())+INTERVAL 1 DAY)-INTERVAL 1 MONTH)*1000');
        $stmnt = $pdo->query('SELECT COUNT(DISTINCT(uuid)) FROM nm_sessions WHERE start >= UNIX_TIMESTAMP(CURDATE()- INTERVAL 1 MONTH)*1000;');
        echo $stmnt->fetch()[0];
        break;
    case 'wrp':
        $stmnt = $pdo->query('SELECT COUNT(DISTINCT(uuid)) FROM nm_sessions WHERE start >= UNIX_TIMESTAMP(CURDATE()- INTERVAL 1 WEEK)*1000');
        echo $stmnt->fetch()[0];
        break;
    case 'drp':
        $stmnt = $pdo->query('SELECT COUNT(DISTINCT(uuid)) FROM nm_sessions WHERE start >= UNIX_TIMESTAMP(CURDATE())*1000');
        echo $stmnt->fetch()[0];
        break;
    case 'dpt':
        $stmnt = $pdo->query('SELECT SUM(time) FROM nm_sessions WHERE start >= (UNIX_TIMESTAMP(CURDATE())*1000)');
        echo formatMilliseconds($stmnt->fetch()[0]);
        break;
    case 'wpt':
        $stmnt = $pdo->query('SELECT SUM(time) FROM nm_sessions WHERE start >= UNIX_TIMESTAMP(CURDATE()- INTERVAL 1 WEEK)*1000');
        echo formatMilliseconds($stmnt->fetch()[0]);
        break;
    case 'tpt':
        $stmnt = $pdo->query('SELECT SUM(playtime) FROM nm_players');
        echo formatMilliseconds($stmnt->fetch()[0]);
        break;
    case 'versions':
        $stmnt2 = $pdo->query('SELECT DISTINCT COUNT(*) FROM nm_players;');
        $total = $stmnt2->fetch()[0];

        echo '<table class="data-table"><thead><tr class="header"><th>Version</th><th>Players</th><th>Population</th></tr></thead><tbody>';
        $stmnt = $pdo->query('SELECT DISTINCT(version) as version, count(*) AS count FROM nm_players GROUP BY version ORDER BY count DESC');
        foreach ($stmnt as $item) {
            echo '<tr class="row"">
            <td>' . getVersion($item['version']) . '</td>
            <td>' . $item['count'] . '</td>
            <td>' . number_format((($item['count'] / $total) * 100), 2, '.', ' ') . '%</td>
            </tr>';
        }
        echo '</tbody></table>';
        break;
    case 'virtualhosts':
        $stmnt = $pdo->query('SELECT DISTINCT COUNT(*) FROM nm_logins;');
        $total = $stmnt->fetch()[0];

        echo '<table class="data-table"><thead><tr class="header"><th>Virtual Host</th><th>Players</th><th>Population</th></tr></thead><tbody>';
        $stmnt = $pdo->query('SELECT DISTINCT(vhost) as vhost, count(*) AS count FROM nm_logins GROUP BY vhost ORDER BY count DESC');
        foreach ($stmnt as $item) {
            $vHost = $item['vhost'];
            $count = $item['count'];

            echo '<tr class="row"">
            <td>' . ($vHost == null ? "Unknown" : $vHost) . '</td>
            <td>' . $count . '</td>
            <td>' . number_format((($count / $total) * 100), 2, '.', ' ') . '%</td>
            </tr>';
        }
        echo '</tbody></table>';
        break;
    case 'onlineplayers':
        $res = array();
        $stmnt = $pdo->prepare('SELECT TIME, ONLINE FROM nm_serverAnalytics WHERE `TIME` > ? ORDER BY `TIME`;');
        $stmnt->bindValue(1, round(microtime(true) * 1000) - 30 * 86400000, PDO::PARAM_INT);
        $stmnt->execute();
        foreach ($stmnt as $row) {
            array_push($res, [(float)$row['TIME'], (int)$row['ONLINE']]);
        }
        echo json_encode($res, JSON_NUMERIC_CHECK);
        break;
    case "is_enabled":
        echo isModuleEnabled($_GET['variable']);
        break;
}