<?php
include '../permissions.php';
include '../MinecraftColorcodes.php';
$colorCodes = new MinecraftColorcodes();
global $webSettings;

include loadLanguage($webSettings);
handlePermission('view_chat');

$load = $_GET['load'];
if (empty($load)) {

    try {
        $total = $pdo->query('SELECT COUNT(*) FROM nm_chat;')->fetchColumn();
        $limit = 10;
        $pages = ceil($total / $limit);
        $page = $_GET['p'];
        $offset = ($page - 1) * $limit;
        $start = $offset + 1;
        $end = min(($offset + $limit), $total);
        $prevlink = ($page > 1) ? '<a chat="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
        $nextlink = ($page < $pages) ? '<a chat="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
        $stmt = $pdo->prepare('SELECT `uuid`, `type`, `message`, `server`, `time` FROM nm_chat ORDER BY `time` DESC LIMIT ? OFFSET ?;');
        $stmt->bindParam(1, $limit, PDO::PARAM_INT);
        $stmt->bindParam(2, $offset, PDO::PARAM_INT);
        $stmt->execute();
        if ($stmt->rowCount() > 0) {

            echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['PLAYER_USERNAME'] . '</th>
                                <th>Type</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20" alt="avatar"> <a href="#' . $row['uuid'] . '" player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . getTypeName($row ['type']) . '</span>
                                    </div>
                                </td>
                                <td class="tdmessage">
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert($row['message']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row ['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
            }
            echo '</tbody>
                        </table>
                    </div>';

            echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';
        } else {
            echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
        }
    } catch (Exception $ex) {
        errorAlert($ex->getMessage());
    }
} else if ($load == 'clear_chat') {
    handlePermission('edit_chat');
    $stmnt = $pdo->prepare('TRUNCATE TABLE nm_chat');
    $stmnt->execute();
} else if ($load == 'load_msg') {
    showMsgChat();
} else if ($load == 'load_party') {
    showPartyChat();
} else if ($load == 'chat_search') {
    showChatSearch();
} else if ($load == 'msg_search') {
    showMsgSearch();
} else if ($load == 'party_search') {
    showPartySearch();
}

function getTypeName($type): string
{
    switch ($type) {
        case 1:
            return 'Chat';
        case 2:
            return 'PM';
        case 3:
            return 'Party';
        default:
            return 'Unknown';
    }
}

function getTypeId($type): int
{
    switch (strtolower($type)) {
        case 'chat':
            return 1;
        case 'pm':
        case 'dm':
        case 'msg':
            return 2;
        case 'party':
            return 3;
        default:
            return 0;
    }
}

function showMsgChat() {
    global $pdo;
    global $colorCodes;
    global $webSettings;
    global $lang;

    try {
        $total = $pdo->query('SELECT COUNT(*) FROM nm_chat WHERE `type`=2;')->fetchColumn();
        $limit = 10;
        $pages = ceil($total / $limit);
        $page = $_GET['p'];
        $offset = ($page - 1) * $limit;
        $start = $offset + 1;
        $end = min(($offset + $limit), $total);
        $prevlink = ($page > 1) ? '<a chat="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
        $nextlink = ($page < $pages) ? '<a chat="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
        $stmt = $pdo->prepare('SELECT `uuid`, `type`, `message`, `server`, `time` FROM nm_chat WHERE `type`=2 ORDER BY `time` DESC LIMIT ? OFFSET ?;');
        $stmt->bindParam(1, $limit, PDO::PARAM_INT);
        $stmt->bindParam(2, $offset, PDO::PARAM_INT);
        $stmt->execute();
        if ($stmt->rowCount() > 0) {

            echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>Sender</th>
                                <th>Receiver</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                $message = $row['message'];
                $receiver = strtok($message, " ");
                $message = replaceFirst($message, $receiver, "");

                echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20" alt="avatar"> <a href="#' . $row['uuid'] . '" player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $receiver . '</span>
                                    </div>
                                </td>
                                <td class="tdmessage">
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert($message) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row ['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
            }
            echo '</tbody>
                        </table>
                    </div>';

            echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';
        } else {
            echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
        }
    } catch (Exception $ex) {
        errorAlert($ex->getMessage());
    }
}

function showPartyChat() {
    global $pdo;
    global $colorCodes;
    global $webSettings;
    global $lang;

    try {
        $total = $pdo->query('SELECT COUNT(*) FROM nm_chat WHERE `type`=3;')->fetchColumn();
        $limit = 10;
        $pages = ceil($total / $limit);
        $page = $_GET['p'];
        $offset = ($page - 1) * $limit;
        $start = $offset + 1;
        $end = min(($offset + $limit), $total);
        $prevlink = ($page > 1) ? '<a chat="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
        $nextlink = ($page < $pages) ? '<a chat="' . ($page + 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
        $stmt = $pdo->prepare('SELECT `uuid`, `type`, `message`, `server`, `time` FROM nm_chat WHERE `type`=3 ORDER BY `time` DESC LIMIT ? OFFSET ?;');
        $stmt->bindParam(1, $limit, PDO::PARAM_INT);
        $stmt->bindParam(2, $offset, PDO::PARAM_INT);
        $stmt->execute();
        if ($stmt->rowCount() > 0) {

            echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['PLAYER_USERNAME'] . '</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20" alt="avatar"> <a href="#' . $row['uuid'] . '" player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td class="tdmessage">
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert($row['message']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row ['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
            }
            echo '</tbody>
                        </table>
                    </div>';

            echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';
        } else {
            echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
        }
    } catch (Exception $ex) {
        errorAlert($ex->getMessage());
    }
}

function showChatSearch() {
    global $pdo;
    global $colorCodes;
    global $webSettings;
    global $lang;

    $search = $_GET['q'];
    $query = '%' . $search . '%';

    //%or%
    $stmt = $pdo->prepare('SELECT username, nm_chat.uuid, `type`, message, server, `time` FROM nm_chat INNER JOIN nm_players ON nm_chat.uuid = nm_players.uuid WHERE `type`=1 AND (username LIKE ? || nm_chat.uuid LIKE ? || message LIKE ? || server LIKE ? || nm_chat.ip LIKE ?) ORDER BY `time` DESC LIMIT 10');
    $stmt->bindParam(1, $query);
    $stmt->bindParam(2, $query);
    $stmt->bindParam(3, $query);
    $stmt->bindParam(4, $query);
    $stmt->bindParam(5, $query);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['PLAYER_USERNAME'] . '</th>
                                <th>' . $lang['CHAT_TYPE'] . '</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20"> <a href="#' . $row['uuid'] . '" player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . getTypeName($row ['type']) . '</span>
                                    </div>
                                </td>
                                <td class="tdmessage">
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert(sanitize($row['message'])) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row ['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . '</span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS_SEARCH'] . ' <strong>' . $search . '</strong></div></div>';
    }
}

function showMsgSearch() {
    global $pdo;
    global $colorCodes;
    global $webSettings;
    global $lang;

    $search = $_GET['q'];
    $query = '%' . $search . '%';

    //%or%
    $stmt = $pdo->prepare('SELECT nm_chat.uuid, `type`, `message`, `server`, `time` FROM nm_chat INNER JOIN nm_players ON nm_chat.uuid = nm_players.uuid WHERE `type`=2 AND (username LIKE ? || nm_chat.uuid LIKE ? || message LIKE ? || server LIKE ? || nm_chat.ip LIKE ?) ORDER BY `time` DESC LIMIT 10');
    $stmt->bindParam(1, $query);
    $stmt->bindParam(2, $query);
    $stmt->bindParam(3, $query);
    $stmt->bindParam(4, $query);
    $stmt->bindParam(5, $query);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>Sender</th>
                                <th>Receiver</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            $message = $row['message'];
            $receiver = strtok($message, " ");
            $message = replaceFirst($message, $receiver, "");

            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20" alt="avatar"> <a player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $receiver . '</a></span>
                                    </div>
                                </td>
                                <td class="tdmessage">
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert(sanitize($message)) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row ['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS_SEARCH'] . ' <strong>' . $search . '</strong></div></div>';
    }
}

function showPartySearch() {
    global $pdo;
    global $colorCodes;
    global $webSettings;
    global $lang;

    $search = $_GET['q'];
    $query = '%' . $search . '%';

    //%or%
    $stmt = $pdo->prepare('SELECT nm_chat.uuid, `type`, `message`, `server`, `time` FROM nm_chat INNER JOIN nm_players ON nm_chat.uuid = nm_players.uuid WHERE `type`=3 AND (username LIKE ? || nm_chat.uuid LIKE ? || message LIKE ? || server LIKE ? || nm_chat.ip LIKE ?) ORDER BY `time` DESC LIMIT 10');
    $stmt->bindParam(1, $query);
    $stmt->bindParam(2, $query);
    $stmt->bindParam(3, $query);
    $stmt->bindParam(4, $query);
    $stmt->bindParam(5, $query);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['PLAYER_USERNAME'] . '</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20" alt="avatar"> <a player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td class="tdmessage">
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert(sanitize($row['message'])) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row ['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS_SEARCH'] . ' <strong>' . $search . '</strong></div></div>';
    }
}