<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
include '../permissions.php';
handlePermission('view_helpop');
global $webSettings;

include loadLanguage($webSettings);

if (!isset($_GET['load'])) {
    try {
        $total = $pdo->query('SELECT COUNT(*) FROM nm_helpop');
        $total = $total->fetchColumn();
        $limit = 10;
        $pages = ceil($total / $limit);
        $page = $_GET['p'];
        $offset = ($page - 1) * $limit;
        $start = $offset + 1;
        $end = min(($offset + $limit), $total);
        $prevlink = ($page > 1) ? '<a helpop="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
        $nextlink = ($page < $pages) ? '<a helpop="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
        $stmt = $pdo->prepare('SELECT `id`, `requester`, `message`, `server`, `time` FROM nm_helpop ORDER BY `id` DESC LIMIT ? OFFSET ?;');
        $stmt->bindParam(1, $limit, PDO::PARAM_INT);
        $stmt->bindParam(2, $offset, PDO::PARAM_INT);
        $stmt->execute();
        if ($stmt->rowCount() > 0) {
            $stmt->setFetchMode(PDO::FETCH_ASSOC);
            $iterator = new IteratorIterator($stmt);

            echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['HELPOP_REQUESTER'] . '</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
								<th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>';
            if (hasPermission('edit_helpop')) {
                echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
            }
            echo '</tr>
                            </thead>
                            <tbody>';
            foreach ($iterator as $row) {

                echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a player="' . $row['requester'] . '"><img src="https://crafatar.com/avatars/' . $row['requester'] . '?size=20"> ' . getName($row['requester']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . sanitize($row['message']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>';
                if (hasPermission('edit_helpop')) {
                    echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                            <button style="background: transparent; border: none" nmdelete-helpop="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                     </div>
                                </td>';
                }
                echo '</tr>';
            }
            echo '</tbody>
                        </table>
                    </div>';

            echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';
        } else {
            echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
        }

    } catch (Exception $ex) {
        echo 'Caught exception: ', $ex->getMessage(), "\n";
    }
} else if ($_GET['load'] == 'delete_helpop') {
    handlePermission('edit_helpop');
    $id = $_GET['id'];

    try {
        $stmnt = $pdo->prepare('DELETE FROM nm_helpop WHERE `id`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $result = $stmnt->execute();
        die($result);
    } catch (PDOException $ex) {
        errorAlert($ex->getMessage());
    }
} else if ($_GET['load'] == 'search') {
    showHelpOPSearch();
}


function showHelpOPSearch() {
    global $pdo;
    global $webSettings;
    global $lang;

    $search = $_GET['q'];
    $query = '%' . $search . '%';

    //%or%
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_helpop INNER JOIN nm_players ON nm_helpop.requester = nm_players.uuid WHERE (username LIKE ? OR nm_helpop.id LIKE ? OR requester LIKE ? OR server LIKE ? OR message LIKE ?)');
    $total->bindParam(1, $query);
    $total->bindParam(2, $query);
    $total->bindParam(3, $query);
    $total->bindParam(4, $query);
    $total->bindParam(5, $query);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a helpopsearch="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '" query="' . $query . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a helpopsearch="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '" query="' . $query . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `requester`, `message`, `server`, `time` FROM nm_helpop INNER JOIN nm_players ON nm_helpop.requester = nm_players.uuid WHERE (username LIKE ? OR nm_helpop.id LIKE ? OR requester LIKE ? OR server LIKE ? OR message LIKE ?) ORDER BY nm_helpop.id DESC LIMIT ? OFFSET ?');
    $stmt->bindParam(1, $query);
    $stmt->bindParam(2, $query);
    $stmt->bindParam(3, $query);
    $stmt->bindParam(4, $query);
    $stmt->bindParam(5, $query);
    $stmt->bindParam(6, $limit, PDO::PARAM_INT);
    $stmt->bindParam(7, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['HELPOP_REQUESTER'] . '</th>
                                <th>' . $lang['VAR_MESSAGE'] . '</th>
								<th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {

            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a href="#' . $row['requester'] . '" player="' . $row['requester'] . '"><img src="https://crafatar.com/avatars/' . $row['requester'] . '?size=20"> ' . getName($row['requester']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['message'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['server'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';
        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS_SEARCH'] . ' <strong>' . $search . '</strong></div></div>';
    }
}