<?php
include '../permissions.php';
include '../MinecraftColorcodes.php';
handlePermission('view_permissions');
$colorCodes = new MinecraftColorcodes();
global $webSettings;

include loadLanguage($webSettings);

$type = $_GET['load'];

if ($type == 'groups') {
    $total = $pdo->query('SELECT COUNT(*) FROM nm_permissions_groups;');
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a nmgroups="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a nmgroups="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`, `name`, `ladder`, `rank` FROM nm_permissions_groups ORDER BY `id` LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $limit, PDO::PARAM_INT);
    $stmt->bindParam(2, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_ID'] . '</th>
                                <th>' . $lang['PERMISSIONS_GROUP_NAME'] . '</th>
                                <th>' . $lang['PERMISSIONS_GROUP_LADDER'] . '</th>
                                <th>' . $lang['PERMISSIONS_GROUP_RANK'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right" > ' . $lang['VAR_ACTION'] . ' </th >';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {

            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['id'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a nmgroupid1="' . $row['id'] . '" nmgroupname1="' . $row['name'] . '">' . $row['name'] . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['ladder'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['rank'] . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                     <!--<button class="nm-button nm-raised nm-raised-edit" nmedit-group="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_EDIT'] . '</button>-->
                                        <button style="background: transparent; border: none" nmedit-group="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: orange">create</i></button>
                                        <button style="background: transparent; border: none" nmdelete-group="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>';
        if (hasPermission('edit_permissions')) {
            echo '<button class="nm-button" id="create-group" modal="create-group"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_CREATE'] . ' </button>';
        }
        echo '</div>';

    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
        if (hasPermission('edit_permissions')) {
            echo '<button class="nm-button" id="create-group" modal="create-group"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_CREATE'] . ' </button>';
        }
    }
    die();
} else if ($type == 'grouppermissions') {
    $groupid = $_GET['groupid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_grouppermissions WHERE `groupid`=?;');
    $total->bindParam(1, $groupid, PDO::PARAM_INT);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a groupid="' . $groupid . '" nmgrouppermissions="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a groupid="' . $groupid . '" nmgrouppermissions="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`,`permission`,`world`,`server`,`expires` FROM nm_permissions_grouppermissions WHERE `groupid`=? ORDER BY `id` DESC LIMIT ? OFFSET ?');
    $stmt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    echo '<div class="data-card-button-box"><a href="#' . $groupid . '" nmgroupmembers="' . $groupid . '" style="bottom: 2px" class="nm-button nm-raised">' . $lang['PERMISSIONS_GROUP_MEMBER_LIST'] . '</a><a href="#' . $groupid . '" nmgroupprefixes="' . $groupid . '" style="bottom: 2px" class="nm-button nm-raised">Prefixes</a><a href="#' . $groupid . '" nmgroupsuffixes="' . $groupid . '" style="bottom: 2px" class="nm-button nm-raised">Suffixes</a><a href="#' . $groupid . '" nmgroupparents="' . $groupid . '" style="bottom: 2px" class="nm-button nm-raised">Parents</a></div>';
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_ID'] . '</th>
                                <th>' . $lang['PERMISSIONS_PERMISSION'] . '</th>
                                <th>' . $lang['PERMISSIONS_PERMISSIONS_WORLD'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['PERMISSIONS_EXPIRES'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . ' </th>';
        }
        echo '</tr>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {

            $world = '<span class="label label-warning">' . $row['world'] . '</span>';
            if ($row['world'] == '') {
                $world = '<span class="label label-success">' . $lang['VAR_ALL'] . '</span>';
            }
            $server = '<span class="label label-warning">' . $row['server'] . '</span>';
            if ($row['server'] == '') {
                $server = '<span class="label label-success">' . $lang['VAR_ALL'] . '</span>';
            }
            $expiredate = date_create($row['expires']);
            $expires = '<span class="label label-warning">' . date_format($expiredate, $webSettings->dateFormat) . '</span>';
            if (is_null($row['expires'])) {
                $expires = '<span class="label label-success">' . $lang['VAR_NEVER'] . '</span>';
            }
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['id'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                    <span>' . $row['permission'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . $world . '
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . $server . '
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . $expires . '
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                            <button style="background: transparent; border: none" groupid="' . $groupid . '" nmedit-group-permission="' . $row['id'] . '"  style="position: relative;right: -24px;"><i class="material-icons" style="color: orange">create</i></button>
                                            <button style="background: transparent; border: none" groupid="' . $groupid . '" nmdelete-group-permission="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                            <!--<button class="nm-button nm-raised nm-raised-edit" groupid="' . $groupid . '" nmedit-group-permission="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_EDIT'] . '</button>
                                            <button class="nm-button nm-raised nm-raised-delete" groupid="' . $groupid . '" nmdelete-group-permission="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackgroups="" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-permission="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_PERMISSION_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>
        <a class="nm-button nm-raised" nmbackgroups="" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-permission="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_PERMISSION_ADD'] . ' </button>';
        }
    }
    die();
} else if ($type == 'groupparents') {
    $groupid = $_GET['groupid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_groupparents WHERE `groupid`=?;');
    $total->bindParam(1, $groupid, PDO::PARAM_INT);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a groupid="' . $groupid . '" nmgroupparents="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a groupid="' . $groupid . '" nmgroupparents="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT nm_permissions_groups.id, nm_permissions_groups.name FROM nm_permissions_groupparents INNER JOIN nm_permissions_groups ON nm_permissions_groupparents.parentgroupid = nm_permissions_groups.id WHERE nm_permissions_groupparents.groupid=? ORDER BY nm_permissions_groupparents.id DESC LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>Group</th>
                                <th>ParentGroup</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </tr>
                            </thead>
                            <tbody>';

        $groupname = getGroupNameByID($groupid);
        foreach ($iterator as $row) {

            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $groupname . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['name'] . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" nmdelete-groupparent="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-delete" nmdelete-groupparent="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">Back</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-parent="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_PARENT_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">No results could be displayed</div></div>
        <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">Back</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-parent="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_PARENT_ADD'] . ' </button>';
        }
    }
    die();
} else if ($type == 'groupprefixes') {
    $groupid = $_GET['groupid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_groupprefixes WHERE `groupid`=?;');
    $total->bindParam(1, $groupid, PDO::PARAM_INT);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a groupid="' . $groupid . '" prefixes="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a groupid="' . $groupid . '" prefixes="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`, `server`, `prefix` FROM nm_permissions_groupprefixes WHERE `groupid`=? ORDER BY id DESC LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['PERMISSIONS_PREFIX'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            $server = '<span class="label label-warning">' . $row['server'] . '</span>';
            if ($row['server'] == '') {
                $server = '<span class="label label-success">' . $lang['VAR_ALL'] . '</span>';
            }
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert($row['prefix'], true) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $server . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" groupid="' . $groupid . '" nmedit-group-prefix="' . $row['id'] . '"  style="position: relative;right: -24px;"><i class="material-icons" style="color: orange">create</i></button>
                                        <button style="background: transparent; border: none" groupid="' . $groupid . '" nmdelete-group-prefix="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-edit" groupid="' . $groupid . '" nmedit-group-prefix="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_EDIT'] . '</button>
                                        <button class="nm-button nm-raised nm-raised-delete" groupid="' . $groupid . '" nmdelete-group-prefix="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">Back</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-prefix="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_PREFIX_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">No results could be displayed</div></div>
        <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">Back</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-prefix="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_PREFIX_ADD'] . ' </button>';
        }
    }
    die();
} else if ($type == 'groupsuffixes') {
    $groupid = $_GET['groupid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_groupsuffixes WHERE `groupid`=?;');
    $total->bindParam(1, $groupid, PDO::PARAM_INT);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a groupid="' . $groupid . '" prefixes="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a groupid="' . $groupid . '" prefixes="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`, `server`, `suffix` FROM nm_permissions_groupsuffixes WHERE `groupid`=? ORDER BY `id` DESC LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['PERMISSIONS_SUFFIX'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            $server = '<span class="label label-warning">' . $row['server'] . '</span>';
            if ($row['server'] == '') {
                $server = '<span class="label label-success">' . $lang['VAR_ALL'] . '</span>';
            }
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert($row['suffix'], true) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $server . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" groupid="' . $groupid . '" nmedit-group-suffix="' . $row['id'] . '"  style="position: relative;right: -24px;"><i class="material-icons" style="color: orange">create</i></button>
                                        <button style="background: transparent; border: none" groupid="' . $groupid . '" nmdelete-group-suffix="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-edit" groupid="' . $groupid . '" nmedit-group-suffix="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_EDIT'] . '</button>
                                            <button class="nm-button nm-raised nm-raised-delete" groupid="' . $groupid . '" nmdelete-group-suffix="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">Back</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-suffix="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_SUFFIX_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">No results could be displayed</div></div>
        <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">Back</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-suffix="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_SUFFIX_ADD'] . ' </button>';
        }
    }
    die();
} else if ($type == 'groupmembers') {
    $groupid = $_GET['groupid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_playergroups WHERE `groupid`=?;');
    $total->bindParam(1, $groupid, PDO::PARAM_INT);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a groupid="' . $groupid . '" nmgroupmembersPage="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a groupid="' . $groupid . '" nmgroupmembersPage="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`,`playeruuid`,`groupid`,`server`,`expires` FROM nm_permissions_playergroups WHERE `groupid`=? ORDER BY `id` DESC LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_PLAYER'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['PERMISSIONS_EXPIRES'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            $server = '<span class="label label-warning">' . $row['server'] . '</span>';
            if ($row['server'] == '') {
                $server = '<span class="label label-success">ALL</span>';
            }
            $expiredate = date_create($row['expires']);
            $expires = '<span class="label label-warning">' . date_format($expiredate, $webSettings->dateFormat) . '</span>';
            if ($row['expires'] == '') {
                $expires = '<span class="label label-success">Never</span>';
            }
            $username = '<span>' . getName($row['playeruuid']) . '</span>';
            if (is_null(getName($row['playeruuid']))) {
                $username = '<span class="label label-danger">Unknown</span>';
            }
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['playeruuid'] . '?size=20"> <a href="#' . $row['playeruuid'] . '" player="' . $row['playeruuid'] . '">' . $username . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $server . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $expires . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" groupid="' . $groupid . '" nmdelete-group-member="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-delete" groupid="' . $groupid . '" nmdelete-group-member="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-group-member="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_MEMBER_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>
        <a class="nm-button nm-raised" nmbackgroupperms="' . $groupid . '" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit" close="create-account">' . $lang['VAR_BACK'] . '</a>
        <button style="right: -40px;" class="nm-button" add-group-member="' . $groupid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_GROUP_MEMBER_ADD'] . ' </button>';
    }
    die();
} else if ($type == 'users') {
    $total = $pdo->query('SELECT COUNT(*) FROM nm_permissions_players;');
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a nmusers="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a nmusers="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `uuid`,`name`,`prefix`,`suffix` FROM nm_permissions_players ORDER BY `name` DESC LIMIT :limit OFFSET :offset;');
    $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
    $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_PLAYER'] . '</th>
                                <th>' . $lang['PERMISSIONS_PREFIX'] . '</th>
                                <th>' . $lang['PERMISSIONS_SUFFIX'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['uuid'] . '?size=20"> <a href="#' . $row['uuid'] . '" userpermissions="' . $row['uuid'] . '">' . $row['name'] . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper"> 
                                        <span>' . $colorCodes->convert($row['prefix'], true) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert($row['suffix'], true) . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" nmedit-permplayer="' . $row['uuid'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: orange">create</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-edit" nmedit-permplayer="' . $row['uuid'] . '" style="position: relative;right: -24px;">' . $lang['VAR_EDIT'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
    }
    die();
} else if ($type == 'userpermissions') {
    $uuid = $_GET['uuid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_playerpermissions WHERE `playeruuid`=?;');
    $total->bindParam(1, $uuid);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a nmuserpermissionspage="' . ($page - 1) . '" useruuid="' . $uuid . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a nmuserpermissionspage="' . ($page - 1) . '" useruuid="' . $uuid . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`,`playeruuid`,`permission`,`world`,`server`,`expires` FROM nm_permissions_playerpermissions WHERE `playeruuid`=? ORDER BY `id` DESC LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $uuid);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    echo '<div class="data-card-button-box"><a nmusergroups="' . $uuid . '" style="bottom: 2px" class="nm-button nm-raised">Groups</a></div>';
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_ID'] . '</th>
                                <th>' . $lang['VAR_PLAYER'] . '</th>
                                <th>' . $lang['PERMISSIONS_PERMISSION'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['PERMISSIONS_PERMISSIONS_WORLD'] . '</th>
                                <th>' . $lang['PERMISSIONS_EXPIRES'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            $world = '<span class="label label-warning">' . $row['world'] . '</span>';
            if ($row['world'] == '') {
                $world = '<span class="label label-success">All</span>';
            }
            $server = '<span class="label label-warning">' . $row['server'] . '</span>';
            if ($row['server'] == '') {
                $server = '<span class="label label-success">All</span>';
            }
            $expiredate = date_create($row['expires']);
            $expires = '<span class="label label-warning">' . date_format($expiredate, $webSettings->dateFormat) . '</span>';
            if (is_null($row['expires'])) {
                $expires = '<span class="label label-success">Never</span>';
            }
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['id'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['playeruuid'] . '?size=20"> <a href="#' . $row['playeruuid'] . '" player="' . $row['playeruuid'] . '">' . getName($row['playeruuid']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['permission'] . '</span>
                                        <!--<div class="nm-input-container" style="position: relative; top: 0; padding: 0 !important;">
                                                <input nmuserpermission="' . $row['id'] . '" uuid="' . $uuid . '" type="text" placeholder="Permission" value="' . $row['permission'] . '">
                                            </div>-->
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $server . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $world . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $expires . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" nmuseruuid="' . $row['playeruuid'] . '" nmdelete-player-permission="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-delete" nmuseruuid="' . $row['playeruuid'] . '" nmdelete-player-permission="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackusers="" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-user-permission="' . $uuid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_PERMISSION_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>
        <a class="nm-button nm-raised" nmbackusers="" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-user-permission="' . $uuid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_PERMISSION_ADD'] . ' </button>';
        }
    }
    die();
} else if ($type == 'usergroups') {
    $uuid = $_GET['uuid'];
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_permissions_playergroups WHERE `playeruuid`=?;');
    $total->bindParam(1, $uuid);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a nmusergroupspage="' . ($page - 1) . '" useruuid="' . $uuid . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a nmusergroupspage="' . ($page - 1) . '" useruuid="' . $uuid . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT `id`, `playeruuid`, `groupid`, `server`, `expires` FROM nm_permissions_playergroups WHERE `playeruuid`=? ORDER BY `id` DESC LIMIT ? OFFSET ?;');
    $stmt->bindParam(1, $uuid);
    $stmt->bindParam(2, $limit, PDO::PARAM_INT);
    $stmt->bindParam(3, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_ID'] . '</th>
                                <th>' . $lang['VAR_PLAYER'] . '</th>
                                <th>Group Name</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['PERMISSIONS_EXPIRES'] . '</th>';
        if (hasPermission('edit_permissions')) {
            echo '<th class="text-right">' . $lang['VAR_ACTION'] . '</th>';
        }
        echo '</tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {
            $server = '<span class="label label-warning">' . $row['server'] . '</span>';
            if ($row['server'] == '') {
                $server = '<span class="label label-success">All</span>';
            }
            $expiredate = date_create($row['expires']);
            $expires = '<span class="label label-warning">' . date_format($expiredate, $webSettings->dateFormat) . '</span>';
            if (is_null($row['expires'])) {
                $expires = '<span class="label label-success">Never</span>';
            }
            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['id'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><img src="https://crafatar.com/avatars/' . $row['playeruuid'] . '?size=20"> <a href="#' . $row['playeruuid'] . '" player="' . $row['playeruuid'] . '">' . getName($row['playeruuid']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . getGroupNameByID($row['groupid']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $server . '</span>
                                    </div>
                                </td>
                               
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $expires . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_permissions')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" groupid="' . $row['groupid'] . '" nmdelete-group-member="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                        <!--<button class="nm-button nm-raised nm-raised-delete" nmuseruuid="' . $row['playeruuid'] . '" nmdelete-player-permission="' . $row['id'] . '" style="position: relative;right: -24px;">' . $lang['VAR_DELETE'] . '</button>-->
                                     </div>
                                </td>';
            }
            echo '</tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <a class="nm-button nm-raised" nmbackusers="" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-user-permission="' . $uuid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_PERMISSION_ADD'] . ' </button>';
        }
        echo '<div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>
        <a class="nm-button nm-raised" nmbackusers="" style="position: relative;top: 2px;left: 55px; margin-left: -48px !important;" type="submit">' . $lang['VAR_BACK'] . '</a>';
        if (hasPermission('edit_permissions')) {
            echo '<button style="right: -40px;" class="nm-button" add-user-permission="' . $uuid . '"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> ' . $lang['PERMISSIONS_PERMISSION_ADD'] . ' </button>';
        }
    }
    die();
} else if ($type == 'delete_group') {
    $id = $_GET['id'];
    $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groups WHERE `id`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $stmnt = $pdo->prepare('SELECT `groupid` FROM nm_permissions_grouppermissions WHERE `groupid`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare('DELETE FROM nm_permissions_grouppermissions WHERE `groupid`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
    }
    $stmnt = $pdo->prepare('DELETE FROM nm_permissions_playergroups WHERE `groupid`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groupparents WHERE `groupid`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groupparents WHERE `parentgroupid`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groupprefixes WHERE `groupid`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groupsuffixes WHERE `groupid`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    echo 'done delete-group';

} else if ($type == 'delete_group_permission') {
    $id = $_GET['id'];
    $stmnt = $pdo->prepare("DELETE FROM nm_permissions_grouppermissions WHERE `id`=?;");
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    echo 'done delete-permission';
} else if ($type == 'delete_group_prefix') {
    $id = $_GET['id'];
    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_groupprefixes WHERE `id`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groupprefixes WHERE `id`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'done delete-group-prefix';
    } else {
        echo "could not find id: $id";
    }
} else if ($type == 'delete_group_suffix') {
    $id = $_GET['id'];
    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_groupsuffixes WHERE `id`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare('DELETE FROM nm_permissions_groupsuffixes WHERE `id`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'done delete-group-suffix';
    } else {
        echo "could not find id: $id";
    }
} else if ($type == 'delete_group_member') {
    $id = $_GET['id'];
    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_playergroups WHERE `id`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare('DELETE FROM nm_permissions_playergroups WHERE `id`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'done delete-group-member';
    } else {
        echo "could not find id: $id";
    }
} else if ($type == 'delete_group_parent') {
    $id = $_GET['id'];
    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_playerparent WHERE `id`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare('DELETE FROM nm_permissions_playerparent WHERE `id`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'done delete-group-parent';
    } else {
        echo "could not find id: $id";
    }
} else if ($type == 'delete_player') {
    $uuid = $_GET['uuid'];
    $stmnt = $pdo->prepare('SELECT `uuid` FROM nm_permissions_players WHERE `uuid`=?;');
    $stmnt->bindParam(1, $uuid);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare("DELETE FROM nm_permissions_players WHERE `uuid`=?;");
        $stmnt->bindParam(1, $uuid);
        $stmnt->execute();
        echo 'done delete-player';
    } else {
        echo "could not find uuid: $uuid";
    }
} else if ($type == 'delete_player_permission') {
    $uuid = $_GET['uuid'];
    $id = $_GET['id'];
    $stmnt = $pdo->prepare('SELECT id FROM nm_permissions_playerpermissions WHERE `id`=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    if ($stmnt->rowCount() > 0) {
        $stmnt = $pdo->prepare('DELETE FROM nm_permissions_playerpermissions WHERE `id`=?;');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'done delete-player-permission';
    } else {
        echo "could not find id: $id";
    }
} else if ($type == 'create_group') {
    $name = $purifier->purify($_GET['name']);
    $ladder = $purifier->purify($_GET['ladder']);
    $rank = $purifier->purify($_GET['rank']);

    try {
        $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_groups WHERE `name`=?;');
        $stmnt->bindParam(1, $name);
        $stmnt->execute();
        if ($stmnt->rowCount() == 0) {
            $stmnt = $pdo->prepare('INSERT INTO nm_permissions_groups (`name`, `ladder`, `rank`) VALUES (?, ?, ?);');
            $stmnt->bindParam(1, $name);
            $stmnt->bindParam(2, $ladder);
            $stmnt->bindParam(3, $rank, PDO::PARAM_INT);
            $stmnt->execute();

            die('true');
        } else {
            die('false');
        }
    } catch (PDOException $ex) {
        die('false ' . $ex->getTraceAsString());
    }
} else if ($type == 'add_groupperm') {
    $groupid = $_GET['groupid'];
    $permission = trim(preg_replace('/\s+/', '', $purifier->purify($_GET['permission'])));
    $server = $purifier->purify($_GET['server']);
    $world = $purifier->purify($_GET['world']);
    $expires = $_GET['expires'] != "" ? strftime('%Y-%m-%d %H:%M:%S', strtotime($_GET['expires'])) : NULL;

    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_grouppermissions WHERE `groupid`=? AND `permission`=? AND `server`=? AND `world`=?;');
    $stmnt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmnt->bindParam(2, $permission);
    $stmnt->bindParam(3, $server);
    $stmnt->bindParam(4, $world);
    $stmnt->execute();
    if ($stmnt->rowCount() == 0) {
        $stmnt = $pdo->prepare('INSERT INTO nm_permissions_grouppermissions (`groupid`, `permission`, `server`, `world`, `expires`) VALUES (?, ?, ?, ?, ?);');
        $stmnt->bindParam(1, $groupid, PDO::PARAM_INT);
        $stmnt->bindParam(2, $permission);
        $stmnt->bindParam(3, $server);
        $stmnt->bindParam(4, $world);
        $stmnt->bindParam(5, $expires);
        $stmnt->execute();

        die('true');
    } else {
        die('false');
    }
} else if ($type == 'update_groupperm') {
    $id = $_GET['id'];
    $permission = trim(preg_replace('/\s+/', '', $purifier->purify($_GET['permission'])));

    $stmnt = $pdo->prepare('UPDATE nm_permissions_grouppermissions SET `permission`=? WHERE `id`=?;');
    $stmnt->bindParam(1, $permission);
    $stmnt->bindParam(2, $id, PDO::PARAM_INT);
    $stmnt->execute();
    die('true');
} else if ($type == 'update_userperm') {
    $id = $_GET['id'];
    $permission = trim(preg_replace('/\s+/', '', $purifier->purify($_GET['permission'])));

    $stmnt = $pdo->prepare('UPDATE nm_permissions_playerpermissions SET `permission`=? WHERE `id`=?;');
    $stmnt->bindParam(1, $permission);
    $stmnt->bindParam(2, $id, PDO::PARAM_INT);
    $stmnt->execute();
    die('true');
} else if ($type == 'add_groupmember') {
    $groupid = $purifier->purify($_GET['groupid']);
    $username = $purifier->purify($_GET['username']);
    $server = $purifier->purify($_GET['server']);

    $uuid = getUuid($username);

    $stmnt = $pdo->prepare('SELECT `playeruuid` FROM nm_permissions_playergroups WHERE `groupid`=? AND `playeruuid`=?;');
    $stmnt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmnt->bindParam(2, $uuid);
    $stmnt->execute();
    if ($stmnt->rowCount() == 0) {
        $stmnt2 = $pdo->prepare('INSERT INTO nm_permissions_playergroups (`groupid`, `playeruuid`, `server`) VALUES (?, ?, ?);');
        $stmnt2->bindParam(1, $groupid, PDO::PARAM_INT);
        $stmnt2->bindParam(2, $uuid);
        $stmnt2->bindParam(3, $server);
        $stmnt2->execute();

        die('true');
    } else {
        die('false');
    }
} else if ($type == 'add_groupparent') {
    $groupid = filter_input(INPUT_GET, 'groupid', FILTER_SANITIZE_STRING);
    $parent = filter_input(INPUT_GET, 'parent', FILTER_SANITIZE_STRING);

    echo $groupid;
    echo $parent;
    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_groupparents WHERE `groupid`=? AND `parentgroupid`=?;');
    $stmnt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmnt->bindParam(2, $parent);
    $stmnt->execute();
    if ($stmnt->rowCount() == 0) {
        $stmnt2 = $pdo->prepare('INSERT INTO nm_permissions_groupparents(`groupid`, `parentgroupid`) VALUES (?, ?);');
        $stmnt2->bindParam(1, $groupid, PDO::PARAM_INT);
        $stmnt2->bindParam(2, $parent);
        $stmnt2->execute();

        die('true');
    } else {
        die('false');
    }
} else if ($type == 'add_groupprefix') {
    $groupid = filter_input(INPUT_GET, 'groupid', FILTER_SANITIZE_STRING);
    $prefix = html_entity_decode($purifier->purify($_GET['prefix']));
    $server = $purifier->purify($_GET['server']);

    $stmnt = $pdo->prepare('SELECT 1 FROM nm_permissions_groupprefixes WHERE `groupid`=? AND `prefix`=?;');
    $stmnt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmnt->bindParam(2, $prefix);
    $stmnt->execute();
    if ($stmnt->rowCount() == 0) {
        $stmnt2 = $pdo->prepare('INSERT INTO nm_permissions_groupprefixes (`groupid`, `prefix`, `server`) VALUES (?, ?, ?);');
        $stmnt2->bindParam(1, $groupid, PDO::PARAM_INT);
        $stmnt2->bindParam(2, $prefix);
        $stmnt2->bindParam(3, $server);
        $stmnt2->execute();

        die('true');
    } else {
        die('false');
    }
} else if ($type == 'add_groupsuffix') {
    $groupid = filter_input(INPUT_GET, 'groupid', FILTER_SANITIZE_STRING);
    $suffix = html_entity_decode($purifier->purify($_GET['suffix']));
    $server = $purifier->purify($_GET['server']);

    $stmnt = $pdo->prepare('SELECT 1 FROM nm_permissions_groupsuffixes WHERE `groupid`=? AND `suffix`=?;');
    $stmnt->bindParam(1, $groupid, PDO::PARAM_INT);
    $stmnt->bindParam(2, $suffix);
    $stmnt->execute();
    if ($stmnt->rowCount() == 0) {
        $stmnt2 = $pdo->prepare('INSERT INTO nm_permissions_groupsuffixes (`groupid`, `suffix`, `server`) VALUES (?, ?, ?);');
        $stmnt2->bindParam(1, $groupid, PDO::PARAM_INT);
        $stmnt2->bindParam(2, $suffix);
        $stmnt2->bindParam(3, $server);
        $stmnt2->execute();

        die('true');
    } else {
        die('false');
    }
} else if ($type == 'add_userperm') {
    $uuid = filter_input(INPUT_GET, 'useruuid', FILTER_SANITIZE_STRING);
    $permission = trim(preg_replace('/\s+/', '', $purifier->purify($_GET['permission'])));
    $server = $purifier->purify($_GET['server']);
    $world = $purifier->purify($_GET['world']);
    $expires = $_GET['expires'] != "" ? strftime('%Y-%m-%d %H:%M:%S', strtotime($_GET['expires'])) : NULL;

    $stmnt = $pdo->prepare('SELECT `id` FROM nm_permissions_playerpermissions WHERE `playeruuid`=? AND `permission`=? AND `server`=? AND `world`=?;');
    $stmnt->bindParam(1, $uuid);
    $stmnt->bindParam(2, $permission);
    $stmnt->bindParam(3, $server);
    $stmnt->bindParam(4, $world2);
    $stmnt->execute();
    if ($stmnt->rowCount() == 0) {
        $stmnt = $pdo->prepare('INSERT INTO nm_permissions_playerpermissions (`playeruuid`, `permission`, `server`, `world`, `expires`) VALUES (?, ?, ?, ?, ?);');
        $stmnt->bindParam(1, $uuid);
        $stmnt->bindParam(2, $permission);
        $stmnt->bindParam(3, $server);
        $stmnt->bindParam(4, $world);
        $stmnt->bindParam(5, $expires);
        $stmnt->execute();

        die('true');
    } else {
        die('false');
    }
} else if ($type == 'edit_user') {
    $uuid = $_GET['useruuid'];
    $prefix = html_entity_decode($purifier->purify($_GET['prefix']));
    $suffix = html_entity_decode($purifier->purify($_GET['suffix']));

    try {
        $stmnt = $pdo->prepare('UPDATE nm_permissions_players SET `prefix`=?, `suffix`=? WHERE `uuid`=?;');
        $stmnt->bindParam(1, $prefix);
        $stmnt->bindParam(2, $suffix);
        $stmnt->bindParam(3, $uuid);
        $stmnt->execute();
        die('true');
    } catch (PDOException $ex) {
        errorAlert($ex->getMessage());
        die('false');
    }
} else if ($type == 'edit_group') {
    $groupid = filter_input(INPUT_GET, 'groupid', FILTER_SANITIZE_STRING);
    $name = $purifier->purify($_GET['name']);
    $ladder = $purifier->purify($_GET['ladder']);
    $rank = $purifier->purify($_GET['rank']);

    try {
        $stmnt = $pdo->prepare('UPDATE nm_permissions_groups SET `name`=?, `ladder`=?, `rank`=? WHERE id=?;');
        $stmnt->bindParam(1, $name);
        $stmnt->bindParam(2, $ladder);
        $stmnt->bindParam(3, $rank, PDO::PARAM_INT);
        $stmnt->bindParam(4, $groupid, PDO::PARAM_INT);
        $stmnt->execute();
        die('true');
    } catch (PDOException $ex) {
        errorAlert($ex->getMessage());
        die('false');
    }
} else if ($type == 'edit_group_permission') {
    $id = $_GET['id'];
    $permission = trim(preg_replace('/\s+/', '', $purifier->purify($_GET['permission'])));
    $world = $purifier->purify($_GET['world']);
    $server = $purifier->purify($_GET['server']);

    try {
        $stmnt = $pdo->prepare('UPDATE nm_permissions_grouppermissions SET `permission`=?, `world`=?, `server`=? WHERE id=?;');
        $stmnt->bindParam(1, $permission);
        $stmnt->bindParam(2, $world);
        $stmnt->bindParam(3, $server);
        $stmnt->bindParam(4, $id, PDO::PARAM_INT);
        $stmnt->execute();
        die('true');
    } catch (PDOException $ex) {
        errorAlert($ex->getMessage());
        die('false');
    }
} else if ($type == 'edit_group_prefix') {
    $id = $_GET['id'];
    $prefix = html_entity_decode($purifier->purify($_GET['prefix']));
    $server = $purifier->purify($_GET['server']);

    try {
        $stmnt = $pdo->prepare('UPDATE nm_permissions_groupprefixes SET `prefix`=?, `server`=? WHERE `id`=?;');
        $stmnt->bindParam(1, $prefix);
        $stmnt->bindParam(2, $server);
        $stmnt->bindParam(3, $id, PDO::PARAM_INT);
        $stmnt->execute();
        die('true');
    } catch (PDOException $ex) {
        errorAlert($ex->getMessage());
        die('false');
    }
} else if ($type == 'edit_group_suffix') {
    $id = $_GET['id'];
    $suffix = html_entity_decode($purifier->purify($_GET['suffix']));
    $server = $purifier->purify($_GET['server']);

    try {
        $stmnt = $pdo->prepare('UPDATE nm_permissions_groupsuffixes SET `suffix`=?, `server`=? WHERE `id`=?;');
        $stmnt->bindParam(1, $suffix);
        $stmnt->bindParam(2, $server);
        $stmnt->bindParam(3, $id, PDO::PARAM_INT);
        $stmnt->execute();
        die('true');
    } catch (PDOException $ex) {
        errorAlert($ex->getMessage());
        die('false');
    }
} else if ($type == 'load_add_group_permission') {
    $id = $_GET['id'];
    echo '<div id="add-group-permission" class="modal" group="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Add permission to group: ' . getGroupNameByID($id) . '</h3>
                <form id="add-group-permission-form" group="' . $id . '">
                    <div class="nm-input-container">
                        <label>Permission</label>
                        <input type="text" name="permission" required>
                    </div>
                    <div class="nm-input-container">
                        <label>Server</label>
                        <input type="text" name="server">
                    </div>
                    <div class="nm-input-container">
                        <label>World</label>
                        <input type="text" name="world">
                    </div>
                    <div class="nm-input-container">
                        <label>Expires</label>
                        <input type="datetime-local" name="expires">
                    </div>             
                    
                    <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="add-group-permission">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" groupid="' . $id . '" close="add-group-permission">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_add_group_member') {
    $id = $_GET['id'];
    echo '<div id="add-group-member" class="modal" group="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Add member to group: ' . getGroupNameByID($id) . '</h3>
                <form id="add-group-member-form" group="' . $id . '">
                    <div class="nm-input-container">
                        <label>Username</label>
                        <input type="text" name="username" required>
                    </div>
                    <div class="nm-input-container">
                        <label>Server</label>
                        <input type="text" name="server">
                    </div>';

    echo '<div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="add-group-member">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="add-group-member">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_add_group_parent') {
    $id = $_GET['id'];
    echo '<div id="add-group-parent" class="modal" group="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Add parent to group ' . getGroupNameByID($id) . '</h3>
                <form id="add-group-parent-form" group="' . $id . '">
                    <div class="nm-input-container">
                        <select name="parent">';
    foreach (getGroups() as $group):
        if ($group['id'] == $id) {
            continue;
        }
        echo '<option value="' . $group['id'] . '">' . $group['name'] . '</option>';
    endforeach;
    echo '</select>
                    </div>';

    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="add-group-parent">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="add-group-parent">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_add_group_prefix') {
    $id = $_GET['id'];
    echo '<div id="add-group-prefix" class="modal" group="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Add prefix to group: ' . getGroupNameByID($id) . '</h3>
                <form id="add-group-prefix-form" group="' . $id . '">
                    <div class="nm-input-container">
                        <label>Prefix</label>
                        <input type="text" name="prefix" required>
                    </div>
                    <div class="nm-input-container">
                        <label>Server</label>
                        <input type="text" name="server">
                    </div>';

    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="add-group-prefix">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="add-group-prefix">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_add_group_suffix') {
    $id = $_GET['id'];
    echo '<div id="add-group-suffix" class="modal" group="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Add suffix to group: ' . getGroupNameByID($id) . '</h3>
                <form id="add-group-suffix-form" group="' . $id . '">
                    <div class="nm-input-container">
                        <label>Suffix</label>
                        <input type="text" name="suffix" required>
                    </div>
                    <div class="nm-input-container">
                        <label>Server</label>
                        <input type="text" name="server">
                    </div>';

    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="add-group-suffix">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="add-group-suffix">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_group') {
    $id = $_GET['id'];
    echo '<div id="nmedit-group" class="modal" group="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Edit group with ID:' . getGroupNameByID($id) . '</h3>
                <form id="nmedit-group-form" group="' . $id . '">';

    foreach ($pdo->query("SHOW COLUMNS FROM `nm_permissions_groups`;") as $item) {
        if ($item['Field'] == 'id') {
            continue;
        }
        $query = 'SELECT ' . $item['Field'] . ' FROM nm_permissions_groups WHERE `id`=?;';
        $stmnt = $pdo->prepare($query);
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        $row = $stmnt->fetch();
        if ($item['Field'] != 'rank') {
            echo '<div class="nm-input-container">
                            <label for="' . $item['Field'] . '">' . $item['Field'] . '</label>
                            <input type="text" id="' . $item['Field'] . '" name="' . $item['Field'] . '" value="' . $row[$item['Field']] . '">
                            </div>';
        } else {
            echo '<div class="nm-input-container">
                            <label for="' . $item['Field'] . '">' . $item['Field'] . '</label>
                            <input type="number" id="' . $item['Field'] . '" name="' . $item['Field'] . '" value="' . $row[$item['Field']] . '">
                            </div>';
        }
    }
    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="nmedit-group">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="nmedit-group">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_add_user_permission') {
    $useruuid = $_GET['uuid'];
    echo '<div id="add-user-permission" class="modal" useruuid="' . $useruuid . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Add permission to user ' . getName($useruuid) . '</h3>
                <form id="add-user-permission-form" useruuid="' . $useruuid . '">
                    <div class="nm-input-container">
                        <label>User UUID</label>
                        <input type="text" name="useruuid" value="' . $useruuid . '" required>
                    </div>
                    <div class="nm-input-container">
                        <label>Permission</label>
                        <input type="text" name="permission" required>
                    </div>
                    <div class="nm-input-container">
                        <label>Server</label>
                        <input type="text" name="server">
                    </div>
                    <div class="nm-input-container">
                        <label>World</label>
                        <input type="text" name="world">
                    </div>
                    <div class="nm-input-container">
                        <label>Expires</label>
                        <input type="datetime-local" name="expires">
                    </div>                    

                    <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="add-user-permission">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" useruuid="' . $useruuid . '" close="add-user-permission">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_edit_permplayer') {
    $useruuid = $_GET['uuid'];
    echo '<div id="nmedit-permplayer" class="modal" useruuid="' . $useruuid . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Editing user: ' . getName($useruuid) . ' (' . $useruuid . ')</h3>
                <form id="nmedit-permplayer-form" useruuid="' . $useruuid . '">';


    foreach ($pdo->query("SHOW COLUMNS FROM `nm_permissions_players`") as $item) {
        if ($item['Field'] == 'uuid' || $item['Field'] == 'name') {
            continue;
        }
        $stmnt = $pdo->prepare('SELECT ' . $item['Field'] . ' FROM nm_permissions_players WHERE uuid=?');
        $stmnt->bindParam(1, $useruuid);
        $stmnt->execute();
        $row = $stmnt->fetch();
        echo '<div class="nm-input-container">
                            <label for="' . $item['Field'] . '">' . $item['Field'] . '</label>
                            <input type="text" id="' . $item['Field'] . '" name="' . $item['Field'] . '" value="' . $row[$item['Field']] . '">
                            </div>';
    }
    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="nmedit-permplayer">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="nmedit-permplayer">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_edit_group_permission') {
    $id = $_GET['id'];
    $groupid = $_GET['groupid'];
    echo '<div id="nmedit-group-permission" class="modal" permid="' . $id . '" group="' . $groupid . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Edit Permission ID: ' . $id . '</h3>
                <form id="nmedit-group-permission-form" permid="' . $id . '" group="' . $groupid . '">';


    foreach ($pdo->query("SHOW COLUMNS FROM `nm_permissions_grouppermissions`") as $item) {
        if ($item['Field'] == 'id' || $item['Field'] == 'groupid' || $item['Field'] == 'expires') {
            continue;
        }
        $stmnt = $pdo->prepare('SELECT ' . $item['Field'] . ' FROM nm_permissions_grouppermissions WHERE id=?');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        $row = $stmnt->fetch();
        echo '<div class="nm-input-container">
                            <label for="' . $item['Field'] . '">' . $item['Field'] . '</label>
                            <input type="text" id="' . $item['Field'] . '" name="' . $item['Field'] . '" value="' . $row[$item['Field']] . '">
                            </div>';
    }
    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="nmedit-group-permission">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="nmedit-group-permission">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_edit_group_prefix') {
    $id = $_GET['id'];
    $groupid = $_GET['groupid'];
    echo '<div id="nmedit-group-prefix" class="modal" prefixid="' . $id . '" group="' . $groupid . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Edit Prefix ID: ' . $id . '</h3>
                <form id="nmedit-group-prefix-form" prefixid="' . $id . '" group="' . $groupid . '">';


    foreach ($pdo->query("SHOW COLUMNS FROM `nm_permissions_groupprefixes`") as $item) {
        if ($item['Field'] == 'id' || $item['Field'] == 'groupid') {
            continue;
        }
        $stmnt = $pdo->prepare('SELECT ' . $item['Field'] . ' FROM nm_permissions_groupprefixes WHERE id=?');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        $row = $stmnt->fetch();
        echo '<div class="nm-input-container">
                            <label for="' . $item['Field'] . '">' . $item['Field'] . '</label>
                            <input type="text" id="' . $item['Field'] . '" name="' . $item['Field'] . '" value="' . $row[$item['Field']] . '">
                            </div>';
    }
    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="nmedit-group-prefix">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="nmedit-group-prefix">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($type == 'load_edit_group_suffix') {
    $id = $_GET['id'];
    $groupid = $_GET['groupid'];
    echo '<div id="nmedit-group-suffix" class="modal" suffixid="' . $id . '" group="' . $groupid . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 15px;font-weight: 200">Edit Suffix ID: ' . $id . '</h3>
                <form id="nmedit-group-suffix-form" suffixid="' . $id . '" group="' . $groupid . '">';


    foreach ($pdo->query("SHOW COLUMNS FROM `nm_permissions_groupsuffixes`") as $item) {
        if ($item['Field'] == 'id' || $item['Field'] == 'groupid') {
            continue;
        }
        $stmnt = $pdo->prepare('SELECT ' . $item['Field'] . ' FROM nm_permissions_groupsuffixes WHERE id=?');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->execute();
        $row = $stmnt->fetch();
        echo '<div class="nm-input-container">
                            <label for="' . $item['Field'] . '">' . $item['Field'] . '</label>
                            <input type="text" id="' . $item['Field'] . '" name="' . $item['Field'] . '" value="' . $row[$item['Field']] . '">
                            </div>';
    }
    echo '          <div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="nmedit-group-suffix">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="nmedit-group-suffix">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
}

function getGroupNameByID($groupId)
{
    global $pdo;
    try {
        $stmnt = $pdo->prepare('SELECT `name` FROM nm_permissions_groups WHERE id=?;');
        $stmnt->bindParam(1, $groupId, PDO::PARAM_INT);
        $stmnt->execute();
        return $stmnt->fetch()['name'];
    } catch (PDOException $ex) {
        return "Unable to find name for group #" . $groupId;
    }
}

function getGroups(): array
{
    global $pdo;
    $sql = 'SELECT id, name FROM nm_permissions_groups;';
    $stmnt = $pdo->query($sql);
    return $stmnt->fetchAll();
}