<?php
include '../permissions.php';
include '../MinecraftColorcodes.php';
handlePermission('view_pre_punishments');
$colorCodes = new MinecraftColorcodes();
global $webSettings;

include loadLanguage($webSettings);

$total = $pdo->query('SELECT COUNT(*) FROM nm_pre_punishments;');
$total = $total->fetchColumn();
$limit = 10;
$pages = ceil($total / $limit);
$page = $_GET['p'];
$offset = ($page - 1) * $limit;
$start = $offset + 1;
$end = min(($offset + $limit), $total);
$prevlink = ($page > 1) ? '<a pre-punishments="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
$nextlink = ($page < $pages) ? '<a pre-punishments="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
$stmt = $pdo->prepare('SELECT `id`, `name`, `type`, `duration`, `server`, `reason` FROM nm_pre_punishments ORDER BY `id` LIMIT ? OFFSET ?;');
$stmt->bindParam(1, $limit, PDO::PARAM_INT);
$stmt->bindParam(2, $offset, PDO::PARAM_INT);
$stmt->execute();
if ($stmt->rowCount() > 0) {
    $stmt->setFetchMode(PDO::FETCH_ASSOC);
    $iterator = new IteratorIterator($stmt);

    echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>ID</th>
                                <th>Name</th>
                                <th>' . $lang['VAR_PUNISHMENT'] . '</th>
                                <th>' . $lang['VAR_DURATION'] . '</th>
                                <th>' . $lang['VAR_SERVER'] . '</th>
                                <th>' . $lang['VAR_REASON'] . '</th>
								<th class="text-right">' . $lang['VAR_ACTION'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
    foreach ($iterator as $row) {

        echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['id'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['name'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . ucwords(getPunishmentType($row['type'])) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . ($row['duration'] == -1 ? 'Permanent' : $row['duration']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . ($row['server'] == null || $row['server'] == '' ? 'Global' : $row['server']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert(sanitize($row['reason'])) . '</span>
                                    </div>
                                </td>';
            if (hasPermission('edit_pre_punishments')) {
                echo '<td class="text-right">
                                     <div class="fb-table-cell-wrapper">
                                        <button style="background: transparent; border: none" nmedit-pre-punishment="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: orange">edit</i></button>
                                        <button style="background: transparent; border: none" nmdelete-pre-punishment="' . $row['id'] . '" style="position: relative;right: -24px;"><i class="material-icons" style="color: red">delete</i></button>
                                     </div>
                                </td>';
            }
                            echo '</tr>';
    }
    echo '</tbody>
                        </table>
                    </div>

                        <div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <button class="nm-button" id="create-pre-punishment" modal="create-pre-punishment"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> Create Punishment Template </button>
                        </div>';
} else {
    echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>
    <button class="nm-button" id="create-pre-punishment" modal="create-pre-punishment"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> Create Punishment Template </button>';
}

function iconGenerator($active): string
{
    if ($active == '0') {
        return '<md-icon class="md-gmp-blue-theme material-icons tl-status-outcome-1">check_circle</md-icon>';
    }
    return '<md-icon class="md-gmp-blue-theme material-icons tl-status-outcome-2">error</md-icon>';
}