<?php
include '../permissions.php';
include '../MinecraftColorcodes.php';
handlePermission('view_punishments');
$colorCodes = new MinecraftColorcodes();
global $webSettings;

include loadLanguage($webSettings);

if (!isset($_GET['load'])) {
    $total = $pdo->query('SELECT COUNT(*) FROM nm_punishments WHERE NOT(type = 20 || type = 21)');
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a punishments="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a punishments="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT id, type, uuid, punisher, reason, time, active FROM nm_punishments WHERE NOT(type = 20 || type = 21) ORDER BY id DESC LIMIT ? OFFSET ?');
    $stmt->bindParam(1, $limit, PDO::PARAM_INT);
    $stmt->bindParam(2, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_PUNISHMENT'] . '</th>
                                <th>' . $lang['VAR_PLAYER'] . '</th>
                                <th>' . $lang['VAR_PUNISHER'] . '</th>
                                <th>' . $lang['VAR_REASON'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {

            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . iconGenerator($row['active']) . '
                                        <span><a punishment="' . $row['id'] . '"> ' . ucwords(getPunishmentType($row['type'])) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a href="#' . $row['uuid'] . '" player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a href="#' . $row['punisher'] . '" player="' . $row['punisher'] . '">' . getName($row ['punisher']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert(sanitize($row['reason'])) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>

                        <div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                            <button class="nm-button" id="create-punishment" modal="create-punishment"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> Create Punishment </button>
                        </div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>
    <button class="nm-button" id="create-punishment" modal="create-punishment"><i class="material-icons" style="position:relative; vertical-align: middle; padding-right: 5px !important; color:gray !important;">add</i> Create Punishment </button>';
    }
} else if ($_GET['load'] == 'search') {
    showPunishmentsSearch();
}

function iconGenerator($active): string
{
    if ($active == '0') {
        return '<md-icon class="md-gmp-blue-theme material-icons tl-status-outcome-1">check_circle</md-icon>';
    }
    return '<md-icon class="md-gmp-blue-theme material-icons tl-status-outcome-2">error</md-icon>';
}

function showPunishmentsSearch() {
    global $pdo;
    global $lang;
    global $webSettings;
    global $colorCodes;

    $search = $_GET['q'];
    $query = '%' . $search . '%';

    //%or%
    $total = $pdo->prepare('SELECT COUNT(*) FROM nm_punishments INNER JOIN nm_players ON nm_punishments.uuid = nm_players.uuid WHERE NOT(type = 20 || type = 21) AND (nm_punishments.id LIKE ? OR nm_punishments.uuid LIKE ? OR nm_punishments.punisher LIKE ? OR username LIKE ? OR nm_punishments.ip LIKE ? OR reason LIKE ?)');
    $total->bindParam(1, $query);
    $total->bindParam(2, $query);
    $total->bindParam(3, $query);
    $total->bindParam(4, $query);
    $total->bindParam(5, $query);
    $total->bindParam(6, $query);
    $total->execute();
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a punishmentsearch="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '" query="' . $query . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a punishmentsearch="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '" query="' . $query . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT nm_players.username, nm_punishments.id, type, nm_punishments.uuid, punisher, reason, time, active FROM nm_punishments INNER JOIN nm_players ON nm_punishments.uuid = nm_players.uuid WHERE NOT(type = 20 || type = 21) && (nm_punishments.id LIKE ? OR nm_punishments.uuid LIKE ? OR nm_punishments.punisher LIKE ? OR username LIKE ? OR nm_punishments.ip LIKE ? OR reason LIKE ?) ORDER BY time DESC LIMIT ? OFFSET ?');
    $stmt->bindParam(1, $query);
    $stmt->bindParam(2, $query);
    $stmt->bindParam(3, $query);
    $stmt->bindParam(4, $query);
    $stmt->bindParam(5, $query);
    $stmt->bindParam(6, $query);
    $stmt->bindParam(7, $limit, PDO::PARAM_INT);
    $stmt->bindParam(8, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_PUNISHMENT'] . '</th>
                                <th>' . $lang['VAR_PLAYER'] . '</th>
                                <th>' . $lang['VAR_PUNISHER'] . '</th>
                                <th>' . $lang['VAR_REASON'] . '</th>
                                <th>' . $lang['VAR_TIME'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {

            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . iconGenerator($row['active']) . '
                                        <span><a punishment="' . $row['id'] . '"> ' . ucwords(getPunishmentType($row['type'])) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a player="' . $row['uuid'] . '">' . getName($row['uuid']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a player="' . $row['punisher'] . '">' . getName($row ['punisher']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $colorCodes->convert(sanitize($row['reason'])) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span> ' . date($webSettings->dateFormat, $row['time'] / 1000) . ' </span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';
        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS_SEARCH'] . ' <strong>' . $search . '</strong></div></div>';
    }
}