<?php
include '../permissions.php';
header('Content-Type: text/html; charset=utf-8');
handlePermission('view_ticket');
global $webSettings;

include loadLanguage($webSettings);

if (!isset($_GET['type'])) {

    ?>

    <script>
        tinymce.init({
            selector: "textarea",
            branding: false,
            hidden_input: false,
            plugins: "image",
        });
        $(function () {
            $("time.timeago").timeago();
        });
    </script>

    <?php

    $id = $_GET['id'];

    $stmt = $pdo->prepare('SELECT `active`, `title`, `creator`, `creation`, `message` FROM nm_tickets_tickets where `id`=?');
    $stmt->bindParam(1, $id, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {

        $row = $stmt->fetchAll()[0];
        $active = $row['active'];

        echo '
    <div class="col-12">
        <div style="color: inherit;"><i style="top: 5px;" class="material-icons">email</i> ' . $row['title'] . '</div>
        <br>
        <div class="data-card">
            <div class="col-6">
                <div class="nm-input-container" style="padding-bottom: 0;">
                    <label>' . $lang['TICKET_ASSIGNEDTO'] . '</label> 
                    <span>' . loadSelect($id, $lang) . '</span>
                </div>
            </div>
            <div class="col-6">
                <div class="nm-input-container" style="padding-bottom: 0;">
                    <label>' . $lang['TICKET_PRIORITY'] . '</label> 
                    <span>' . loadPrioritySelect($id, $lang) . '</span>
                </div>
            </div>
        </div>
    </div>

    <div class="col-12">
        <div class="data-card">
            <div class="data-card-header">
                <div class="data-card-header-title" id="ticket-title">' . getName($row['creator']) . '
                    <small style="margin-left: 5px;">
                        asked
                        <time class="timeago" datetime="' . date('c', round($row['creation'] / 1000)) . '">' . date($webSettings->dateFormat, $row['creation'] / 1000) . '</time>
                    </small>
                </div>
            </div>
            <div class="data-card-body" style="padding: 3px;">
                <div class="ticket-container">
                    ' . $row['message'] . '
                </div>
            </div>
        </div>
    </div>';

        $stmnt1 = $pdo->prepare('SELECT id, uuid, time, message FROM nm_tickets_messages WHERE ticket_id=?');
        $stmnt1->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt1->execute();
        if ($stmnt1->rowCount() > 0) {
            $data = $stmnt1->fetchAll();
            foreach ($data as $row) {
                echo '<div id="ticket-' . $row['id'] . '" class="col-12">
                    <div class="data-card">
                        <div class="data-card-header">
                            <div class="data-card-header-title" id="ticket-title">' . getName($row['uuid']) . '
                                <small style="margin-left: 5px;">
                                    replied
                                    <time class="timeago" datetime="' . date('c', round($row['time'] / 1000)) . '">' . date($webSettings->dateFormat, $row['time'] / 1000) . '</time>
                                </small>';
                /*if (getName($row['uuid']) == $_SESSION['user']->getUsername()) {
                    echo '<a id="ticket-edit-message" ticketid="' . $row['id'] . '" class="edit-ticket-message-button material-icons">edit</a>';
                }*/
                echo '</div>
                        </div>
                        <div class="data-card-body" style="padding: 3px;">
                            <div class="ticket-container">
                                ' . $row['message'] . '
                            </div>
                        </div>
                    </div>
                </div>';
            }
        }

        echo '<div id="cached-message">
          </div>';

        echo '<div class="col-12">
          <textarea style="width: 100%" id="ticket-message" required></textarea>
          </div>';

        echo '<div class="col-12 text-right no-padding" style="width: 100% !important;">';
        if ($active == '1') {
            echo '<button class="nm-button nm-raised-delete" ticketid="' . $id . '" id="ticket-close">' . $lang['TICKET_CLOSE'] . '</button>';
        }
        echo '<button class="nm-button nm-raised" ticketid="' . $id . '" id="ticket-respond">' . $lang['TICKET_ANSWER'] . '</button>';
        echo '</div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
    }
} else if ($_GET['type'] == 'assign_ticket') {
    handlePermission('assign_ticket');
    $id = $_GET['id'];
    $user = $_GET['account'];
    $time = round(microtime(true) * 1000);

    try {
        $stmnt = $pdo->prepare('UPDATE nm_tickets_tickets SET `assigned_from`=?, `assigned_to`=?, `assigned_on`=? WHERE `id`=?;');
        $stmnt->bindParam(1, $_SESSION['user']->getUsername());
        $stmnt->bindParam(2, $user);
        $stmnt->bindParam(3, $time, PDO::PARAM_INT);
        $stmnt->bindParam(4, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'Assigned ticket ' . $id . ' to ' . $user;
    } catch (PDOException $ex) {
        echo 'ERROR ' . $ex->getLine() . " : " . $ex->getMessage();
    }
} else if ($_GET['type'] == 'priority_ticket') {
    handlePermission('priority_ticket');
    $id = $_GET['id'];
    $priority = $_GET['priority'];

    try {
        $stmnt = $pdo->prepare('UPDATE nm_tickets_tickets SET `priority`=? WHERE `id`=?;');
        $stmnt->bindParam(1, $priority, PDO::PARAM_INT);
        $stmnt->bindParam(2, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'Priority set to ' . $priority . ' for ticket ' . $id . '';
    } catch (PDOException $ex) {
        echo 'ERROR ' . $ex->getLine() . " : " . $ex->getMessage();
    }
} else if ($_GET['type'] == 'respond_ticket') {
    handlePermission('respond_ticket');
    $id = $_GET['id'];
    $message = $purifier->purify(urldecode($_GET['message']));
    $time = round(microtime(true) * 1000);
    $user = getUuid($_SESSION['user']->getUsername());
    if ($user == null) {
        echo 'ERROR Could not find uuid by username: ' . $_SESSION['user']->getUsername();
        return;
    }

    try {
        $stmnt = $pdo->prepare('UPDATE nm_tickets_tickets SET `last_update`=?, `last_answer`=? WHERE `id`=?;');
        $stmnt->bindParam(1, $time);
        $stmnt->bindParam(2, $user);
        $stmnt->bindParam(3, $id, PDO::PARAM_INT);
        $stmnt->execute();

        $stmnt = $pdo->prepare('INSERT INTO nm_tickets_messages(ticket_id, uuid, message, time) VALUES (?, ?, ?, ?);');
        $stmnt->bindParam(1, $id, PDO::PARAM_INT);
        $stmnt->bindParam(2, $user);
        $stmnt->bindParam(3, $message);
        $stmnt->bindParam(4, $time, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'Responded to ticket ' . $id . ' by ' . $user . ' message ' . $message;
    } catch (Exception $ex) {
        echo 'ERROR ' . $ex->getLine() . " : " . $ex->getMessage();
    }
} else if ($_GET['type'] == 'delete_ticket') {
    handlePermission('close_ticket');
    $id = $_GET['id'];
    $time = round(microtime(true) * 1000);
    $user = getUuid($_SESSION['user']->getUsername());
    if ($user == null) {
        echo 'ERROR Could not find uuid by username: ' . $_SESSION['user']->getUsername();
        return;
    }

    try {
        $stmnt = $pdo->prepare('UPDATE nm_tickets_tickets SET closed_on=?, closed_by=?, active=0 WHERE id=?;');
        $stmnt->bindParam(1, $time);
        $stmnt->bindParam(2, $user);
        $stmnt->bindParam(3, $id, PDO::PARAM_INT);
        $stmnt->execute();
        echo 'Closed ticket ' . $id . ' by ' . $user;
    } catch (PDOException $ex) {
        echo 'ERROR ' . $ex->getLine() . " : " . $ex->getMessage();
    }
} else if ($_GET['type'] == 'load_edit_ticket_message') {
    $id = $_GET['id'];

    echo '<div id="nmedit-ticket-message" class="modal" ticketid="' . $id . '">
            <div class="modal-content" style="width: 600px !important;">
            <h3 style="font-size: 16px;font-weight: 200;">Edit message</h3>
            <hr style="width: calc(100% - 20px)">
                <form id="nmedit-ticket-message-form" ticketid="' . $id . '">';

    $stmnt = $pdo->prepare('SELECT message FROM nm_tickets_messages WHERE id=?;');
    $stmnt->bindParam(1, $id, 1);
    $stmnt->execute();
    $row = $stmnt->fetch();

    echo '
          <div class="col-12">
          <textarea style="width: 100%" id="new-ticket-message" required>' . $row['message'] . '</textarea>
          </div>';

    echo '<div class="nm-input-container" style="text-align: right;padding-right: 16px;margin-bottom: -20px;">
                        <button class="nm-button" type="button" style="position: relative;right: -24px;" close="nmedit-ticket-message">Cancel</button> <button class="nm-button nm-raised" style="position: relative;right: -24px;" type="submit" close="nmedit-ticket-message">Save</button>
                    </div>
                </form>
            </div>
        </div>';
    die();
} else if ($_GET['type'] == 'edit_ticket_message') {
    $id = $_GET['id'];
    $message = $purifier->purify($_GET['message']);
    $time = round(microtime(true) * 1000);
    $user = getUuid($_SESSION['user']->getUsername());
    if ($user == null) {
        echo 'ERROR Could not find uuid by username: ' . $_SESSION['user']->getUsername();
        return;
    }

    try {
        $stmnt = $pdo->prepare('UPDATE nm_tickets_messages SET `uuid`=?, `message`=?, `time`=? WHERE `id`=?;');
        $stmnt->bindParam(1, $user);
        $stmnt->bindParam(2, $message);
        $stmnt->bindParam(3, $time, PDO::PARAM_INT);
        $stmnt->bindParam(4, $id, PDO::PARAM_INT);
        $stmnt->execute();
        die('true');
    } catch (PDOException $ex) {
        echo 'ERROR ' . $ex->getLine() . " : " . $ex->getTraceAsString();
    }
}

function returnName($name)
{
    if (strlen($name) == 36) {
        return getName($name);
    }
    return $name;
}

function loadSelect($id, $lang): string
{
    global $pdo;
    $res1 = '<select id="assign-ticket" assign="' . $id . '">';
    $stmnt = $pdo->prepare('SELECT assigned_to FROM nm_tickets_tickets WHERE id=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $dat = $stmnt->fetchAll();
    $stmnt = $pdo->query('SELECT username FROM nm_accounts');
    $dat1 = $stmnt->fetchAll();
    $res1 = $res1 . '<option disabled selected value>' . $lang['TEXT_SELECTOPTION'] . '</option>';
    foreach ($dat1 as $row) {
        $select = '';
        if ($row['username'] == $dat['assigned_to']) {
            $select = 'selected';
        }
        $res1 = $res1 . '<option ' . $select . ' value="' . $row['username'] . '">' . $row['username'] . '</option>';
    }
    return $res1 . '</select>';
}

function loadPrioritySelect($id, $lang): string
{
    global $pdo;
    $res1 = '<select id="priority-ticket" priority="' . $id . '">';
    $stmnt = $pdo->prepare('SELECT priority FROM nm_tickets_tickets WHERE id=?;');
    $stmnt->bindParam(1, $id, PDO::PARAM_INT);
    $stmnt->execute();
    $res = $stmnt->fetch();
    //$res1 = $res1 . '<option disabled selected value>' . $lang['TEXT_SELECTOPTION'] . '</option>';
    $arr = array(0, 1, 2, 3);
    foreach ($arr as $row) {
        $select = '';
        if ($row == $res['priority']) {
            $select = 'selected';
        }
        $res1 = $res1 . '<option ' . $select . ' value="' . $row . '">' . priority($row, $lang) . '</option>';
    }
    return $res1 . '</select>';
}

function priority($priority, $lang)
{
    switch ($priority) {
        case "1":
            return $lang['TICKET_PRIORITY_LOW'];
        case "2":
            return $lang['TICKET_PRIORITY_MEDIUM'];
        case "3":
            return $lang['TICKET_PRIORITY_HIGH'];
        default:
            return $lang['TICKET_PRIORITY_NO_PRIORITY'];
    }
}