<?php
include '../permissions.php';
handlePermission('view_tickets');
global $webSettings;
include loadLanguage($webSettings);

if (!isset($_GET['load'])) {
    $total = $pdo->query('SELECT COUNT(*) FROM nm_tickets_tickets');
    $total = $total->fetchColumn();
    $limit = 10;
    $pages = ceil($total / $limit);
    $page = $_GET['p'];
    $offset = ($page - 1) * $limit;
    $start = $offset + 1;
    $end = min(($offset + $limit), $total);
    $prevlink = ($page > 1) ? '<a tickets="' . ($page - 1) . '" class="nm-pagination-icon"  page="' . ($page - 1) . '"><i class="material-icons">keyboard_arrow_left</i></a>' : '';
    $nextlink = ($page < $pages) ? '<a tickets="' . ($page - 1) . '" class="nm-pagination-icon" page="' . ($page + 1) . '"><i class="material-icons">keyboard_arrow_right</i></a>' : '';
    $stmt = $pdo->prepare('SELECT id, creator, title, assigned_to, creation, last_update, active FROM nm_tickets_tickets ORDER BY last_update DESC LIMIT ? OFFSET ?');
    $stmt->bindParam(1, $limit, PDO::PARAM_INT);
    $stmt->bindParam(2, $offset, PDO::PARAM_INT);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['VAR_TICKET'] . '</th>
                                <th>' . $lang['VAR_CREATOR'] . '</th>
                                <th>' . $lang['TICKET_TITLE'] . '</th>
                                <th>' . $lang['TICKET_ASSIGNEDTO'] . '</th>
                                <th>' . $lang['TICKET_CREATED'] . '</th>
                                <th>' . $lang['TICKET_LASTUPDATE'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {


            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . iconGenerator($row['active']) . '
                                        <a ticket="' . $row['id'] . '"> ' . $lang['TICKET_TICKET'] . ' #' . $row['id'] . ' </a>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a href="#' . $row['creator'] . '" player="' . $row['creator'] . '">' . getName($row['creator']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['title'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . assigned($row['assigned_to']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . date($webSettings->dateFormat, $row['creation'] / 1000) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . date($webSettings->dateFormat, $row['last_update'] / 1000) . '</span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';

        echo '<div class="data-card-footer-pagination">
                            <div class="nm-pagination-bar">' . $start . '-' . $end . ' of ' . $total . ' ' . $prevlink . $nextlink . '</div>
                        </div>';


    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS'] . '</div></div>';
    }
} else if ($_GET['load'] == 'search') {
    showTicketsSearch();
}

function iconGenerator($active): string
{
    if ($active == '0') {
        return '<md-icon class="md-gmp-blue-theme material-icons tl-status-outcome-1">check_circle</md-icon>';
    }
    return '<md-icon class="md-gmp-blue-theme material-icons tl-status-outcome-2">error</md-icon>';
}

function assigned($assigned)
{
    if ($assigned == '') {
        return '—';
    }
    return $assigned;
}

function showTicketsSearch() {
    global $pdo;
    global $lang;
    global $webSettings;

    $search = $_GET['q'];
    $query = '%' . $search . '%';

    //%or%
    $stmt = $pdo->prepare('SELECT nm_tickets_tickets.id, username, creator, title, assigned_to, last_update FROM nm_tickets_tickets INNER JOIN nm_players ON nm_tickets_tickets.creator = nm_players.uuid WHERE (title LIKE ? || username LIKE ? || creator LIKE ? || last_update LIKE ? || assigned_to LIKE ?) LIMIT 10');
    $stmt->bindParam(1, $query);
    $stmt->bindParam(2, $query);
    $stmt->bindParam(3, $query);
    $stmt->bindParam(4, $query);
    $stmt->bindParam(5, $query);
    $stmt->execute();
    if ($stmt->rowCount() > 0) {
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $iterator = new IteratorIterator($stmt);

        echo '<div class="data-card-body">
                        <table class="fb-table-elem">
                            <thead>
                            <tr>
                                <th>' . $lang['TICKET_TICKET'] . '</th>
                                <th>' . $lang['VAR_CREATOR'] . '</th>
                                <th>' . $lang['TICKET_TITLE'] . '</th>
                                <th>' . $lang['TICKET_ASSIGNEDTO'] . '</th>
                                <th>' . $lang['TICKET_LASTUPDATE'] . '</th>
                            </tr>
                            </thead>
                            <tbody>';
        foreach ($iterator as $row) {


            echo '<tr>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        ' . iconGenerator($row['active']) . '
                                        <a> ' . $lang['TICKET_TICKET'] . ' #' . $row['id'] . ' </a>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span><a href="#player_' . $row['creator'] . '">' . getName($row['creator']) . '</a></span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' . $row['title'] . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>'. assigned($row['assigned_to']) . '</span>
                                    </div>
                                </td>
                                <td>
                                    <div class="fb-table-cell-wrapper">
                                        <span>' .date($webSettings->dateFormat, $row['last_update']/1000) . '</span>
                                    </div>
                                </td>
                            </tr>';
        }
        echo '</tbody>
                        </table>
                    </div>';
    } else {
        echo '<div class="data-card-body"><div class="nm-search-results-empty">' . $lang['TEXT_NORESULTS_SEARCH'] . ' <strong>' . $search . '</strong></div></div>';
    }
}