<?php
include '../dep/permissions.php';
handlePermission('view_players');
global $webSettings;
if (isset($_COOKIE['language'])) {
    $language = $_COOKIE['language'];
    $langdir = "../dep/languages/";
    if (is_dir($langdir)) {
        if ($dh = opendir($langdir)) {
            while (($file = readdir($dh)) !== false) {
                if ($file != '..' && $file != '.') {
                    $filename = pathinfo($file, PATHINFO_FILENAME);
                    $result = $langdir . $file;
                    if ($language == $filename) {
                        include $result;
                    }
                }
            }
            closedir($dh);
        }
    }
} else {
    include '../dep/languages/' . $webSettings->defaultLanguage . '.php';
}
?>
<div class="container">
    <div class="content">
        <div class="row">
            <div class="col-12">
                <div class="data-card" style="margin-top: 20px">
                    <div class="data-card-header">
                        <div class="data-card-search-box">
                            <i class="material-icons">search</i>
                            <form>
                                <input type="text" id="search-input" class="data-card-input"
                                       placeholder="<?php echo $lang['PLAYER_SEARCH']; ?>" autocomplete="off">
                            </form>
                        </div>
                    </div>
                    <div id="data-card-content">
                        <div class="data-card-body">
                            <div class="nm-search-results-empty"><?php echo $lang['VAR_LOADING']; ?></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<script>
    $(function () {
        $("#data-card-content").load('../inc/php/dep/pages/players.php?p=1', function () {
            console.log('loaded');
        });
    });
    $("input#search-input").on('focus', function () {
        console.log('triggered');
        $(".data-card-header").each(function () {
            $(this).addClass('is-editing');
        });
    });

    $("input#search-input").on('focusout', function () {
        console.log('triggered');
        $(".data-card-header").each(function () {
            $(this).removeClass('is-editing');
        });
        if ($(this).val().length === 0) {
            $("#data-card-content").load('../inc/php/dep/pages/players.php?p=1', function () {
                console.log('player load performed');
            });
        }
    });

    /* ---------- PLAYER SEARCH -------------- */
    $("input#search-input").on('keyup', function () {
        $("#data-card-content").load('../inc/php/dep/pages/players.php?load=search&q=' + this.value + "&p=1", function () {
            console.log('load performed');
        });
        if ($(this).val().length === 0) {
            console.log($(this).val().length);
            $("#data-card-content").load('../inc/php/dep/pages/players.php?p=1', function () {
                console.log('load performed');
            });
        }
    });

    $(document).on('click', 'a', function () {
        if (this.hasAttribute('players')) {
            let attr = $(this).attr('page');
            if (typeof attr !== typeof undefined && attr !== false) {
                $("#data-card-content").load('../inc/php/dep/pages/players.php?p=' + attr, function () {
                    console.log('player load performed');
                });
            }
        } else if (this.hasAttribute('playersearch')) {
            let attr = $(this).attr('page');
            let query = $(this).attr('query');
            if (typeof attr !== typeof undefined && attr !== false) {
                $("#data-card-content").load('../inc/php/dep/pages/players.php?load=search&p=' + attr + '&q=' + query, function () {
                    console.log('player load performed');
                });
            }
        }
    });
</script>