<?php
$configFile = parse_ini_file('protected/config.ini');
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    if (isset($_POST['host'])) {
        $host = $_POST['host'];
        $username = $_POST['username'];
        $password = $_POST['password'];
        $port = $_POST['port'];
        $database = $_POST['database'];
        $encoding = "utf8mb4";

        try {
            $configFile['db_host'] = $host;
            $configFile['db_port'] = $port;
            $configFile['db_database'] = $database;
            $configFile['db_username'] = $username;
            $configFile['db_password'] = $password;

            $success = write_ini_file('protected/config.ini', $configFile);
            if (!$success) {
                die('file');
            }

            $pdo = new PDO('mysql:host=' .
                $host . ';port=' . $port . ';dbname=' .
                $database . ";charset=" . $encoding, $username, $password);
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

            try {
                $pdo->query('SELECT 1 from nm_values;');
            } catch (PDOException $ex) {
                die('no tables');
            }

            $pdo = null;
            die('true');
        } catch (PDOException $e) {
            die('connection ' . $e->getMessage());

        }
    } else {
        include "protected/config.php";
        $username = $_POST['username'];
        $password = $_POST['password'];
        $usergroup = 'administrator';
        $notifications = '[]';

        try {
            $statement = $pdo->prepare('SELECT 1 FROM nm_accountgroups WHERE name=?;');
            $statement->bindParam(1, $usergroup, PDO::PARAM_STR);
            $statement->execute();
            if ($statement->rowCount() == 0) {
                $statement = $pdo->prepare("INSERT into nm_accountgroups(name, administrator) VALUES ('administrator', TRUE );");
                $statement->execute();
            }


            $statement = $pdo->prepare('SELECT 1 FROM nm_accounts WHERE username=?;');
            $statement->bindParam(1, $username, PDO::PARAM_STR);
            $statement->execute();
            if ($statement->rowCount() == 0) {
                $statement = $pdo->prepare('INSERT INTO nm_accounts(username, password, notifications, usergroup) VALUES (?, ?, ?, ?);');
                //$salt = 'HM$75Dh(r^#A22j@_';
                $pwhash = password_hash($password, PASSWORD_BCRYPT);
                $statement->bindParam(1, $username, PDO::PARAM_STR);
                $statement->bindParam(2, $pwhash, PDO::PARAM_STR);
                $statement->bindParam(3, $notifications, PDO::PARAM_STR);
                $statement->bindParam(4, $usergroup, PDO::PARAM_STR);
                $statement->execute();
            }
        } catch (PDOException $ex) {
            die('connection ' . $e->getTraceAsString());
        }
        die('true');
    }
}

/**
 * Write an ini configuration file
 *
 * @param string $file
 * @param array $array
 * @return bool
 */
function write_ini_file($file, $array = [])
{
    // check first argument is string
    if (!is_string($file)) {
        throw new InvalidArgumentException('Function argument 1 must be a string.');
    }

    // check second argument is array
    if (!is_array($array)) {
        throw new InvalidArgumentException('Function argument 2 must be an array.');
    }

    // process array
    $data = array();
    foreach ($array as $key => $val) {
        if (is_array($val)) {
            $data[] = "[$key]";
            foreach ($val as $skey => $sval) {
                if (is_array($sval)) {
                    foreach ($sval as $_skey => $_sval) {
                        if (is_numeric($_skey)) {
                            $data[] = $skey . '[] = ' . (is_numeric($_sval) ? $_sval : (ctype_upper($_sval) ? $_sval : '"' . $_sval . '"'));
                        } else {
                            $data[] = $skey . '[' . $_skey . '] = ' . (is_numeric($_sval) ? $_sval : (ctype_upper($_sval) ? $_sval : '"' . $_sval . '"'));
                        }
                    }
                } else {
                    $data[] = $skey . ' = ' . (is_numeric($sval) ? $sval : (ctype_upper($sval) ? $sval : '"' . $sval . '"'));
                }
            }
        } else {
            $data[] = $key . ' = ' . (is_numeric($val) ? $val : (ctype_upper($val) ? $val : '"' . $val . '"'));
        }
        // empty line
        $data[] = null;
    }

    // open file pointer, init flock options
    $fp = fopen($file, 'w');
    $retries = 0;
    $max_retries = 100;

    if (!$fp) {
        return false;
    }

    // loop until get lock, or reach max retries
    do {
        if ($retries > 0) {
            usleep(rand(1, 5000));
        }
        $retries += 1;
    } while (!flock($fp, LOCK_EX) && $retries <= $max_retries);

    // couldn't get the lock
    if ($retries == $max_retries) {
        return false;
    }

    // got lock, write data
    fwrite($fp, implode(PHP_EOL, $data) . PHP_EOL);

    // release lock
    flock($fp, LOCK_UN);
    fclose($fp);

    return true;
}